local addonName, T = ...
local EV = T.Evie

local function acquireT(parent, a, ...)
	if type(a) == "nil" then return parent end
	if type(parent[a]) ~= "table" then
		parent[a] = {}
	end
	return acquireT(parent[a], ...)
end
local function get(parent, a, ...)
	if a == nil then return parent end
	if type(parent) ~= "table" then return end
	return get(parent[a], ...)
end

EV.RegisterEvent("PET_BATTLE_OPENING_DONE", function()
	for i=1, C_PetBattles.IsPlayerNPC(2) and C_PetBattles.GetNumPets(2) or 0 do
		local id, lvl, hp, ap, sp, name, name2 = C_PetBattles.GetPetSpeciesID(2, i),
			C_PetBattles.GetLevel(2,i), C_PetBattles.GetHealth(2,i),
			C_PetBattles.GetPower(2,i), C_PetBattles.GetSpeed(2,i), C_PetBattles.GetName(2, i)
		if id then
			local info = acquireT(_G, "LittleBattlerData", id)
			info[1] = ((name or "") ~= "" and name) or name2
			info[2], info[3], info[4], info[5] = lvl, hp, ap, sp
		end
	end
end)
EV.RegisterEvent("GOSSIP_SHOW", function()
	local id = T.IsTamerNPC(tonumber((UnitGUID("npc") or "0"):sub(6, 10), 16))
	if id then
		local info = acquireT(_G, "LittleBattlerData")
		info["tamerName-" .. id] = UnitName("npc")
	end
end)

EV.RegisterEvent("PLAYER_LOGOUT", function()
	if IsAddOnLoaded("Blizzard_PetJournal") then
		local settings = acquireT(_G, "LittleBattlerSettings")
		settings.JournalSort = C_PetJournal.GetPetSortParameter()
	end
end)
EV.RegisterEvent("ADDON_LOADED", function(_, addon)
	if addon == addonName then
		local sort = get(_G, "LittleBattlerSettings", "JournalSort")
		if sort then
			C_PetJournal.SetPetSortParameter(LittleBattlerSettings.JournalSort)
		end
	end
end)


EV.RegisterEvent("QUEST_DETAIL", function(...)
	if not IsLeftShiftKeyDown() and T.IsTamerQuest(GetQuestID()) and select(2,GetNumQuestLogEntries()) < MAX_QUESTS then
		AcceptQuest()
	end
end)
EV.RegisterEvent("QUEST_COMPLETE", function()
	if not IsLeftShiftKeyDown() and T.IsTamerQuest(GetQuestID()) then
		GetQuestReward(1)
	end
end)
EV.RegisterEvent("QUEST_AUTOCOMPLETE", function(_, qid)
	if not IsLeftShiftKeyDown() and T.IsTamerQuest(qid) then
		ShowQuestComplete(GetQuestLogIndexByID(qid))
	end
end)

local replaceHat, unhatter = false
local function setReplacementHat(hat)
	local set = acquireT(_G, "LittleBattlerCharSettings")
	set.replacementHat, replaceHat = hat, hat
end
local function unhat()
	if replaceHat and GetInventoryItemID("player", 1) == 92738 and GetItemCount(replaceHat) > 0 then
		if not (InCombatLockdown() or IsInventoryItemLocked(1)) then
			EquipItemByName(replaceHat)
		end
		unhatter:Play()
	else
		setReplacementHat(false)
		unhatter:Stop()
	end
end
unhatter = EV.CreateTimer(0.25, unhat, false)
EV.RegisterEvent("PET_BATTLE_SOON", function()
	if GetInventoryItemID("player", 1) ~= 92738 and GetItemCount(92738) > 0 then
		for i=1,3 do
			local g = C_PetJournal.GetPetLoadOutInfo(i)
			if g then
				local hp, _, _, lvl = C_PetJournal.GetPetStats(g), C_PetJournal.GetPetInfoByPetID(g)
				if lvl < 25 and hp > 0 then
					setReplacementHat(GetInventoryItemLink("player", 1))
					unhatter:Stop()
					EquipItemByName(92738)
					break
				end
			end
		end
	end
end)
EV.RegisterEvent("PLAYER_REGEN_DISABLED", unhat)
EV.RegisterEvent("PET_BATTLE_OPENING_DONE", unhat)
EV.RegisterEvent("PET_BATTLE_CLOSE", unhat)
EV.RegisterEvent("ADDON_LOADED", function(_, a)
	if a == addonName then
		replaceHat = get(_G, "LittleBattlerCharSettings", "replacementHat") or false
		if replaceHat then
			EV.RegisterEvent("PLAYER_ENTERING_WORLD", function()
				if GetInventoryItemID("player", 1) == 92738 then
					EquipItemByName(replaceHat)
				end
				return "remove"
			end)
		end
	end
end)

do
	local f, LIMIT, tex, btn = CreateFrame("BUTTON", "LittleBattlerSurrenderButton", nil, "SecureHandlerStateTemplate,SecureHandlerClickTemplate"), 0.65
	local function onLoaded(_, addon)
		if addon ~= "Blizzard_PetBattleUI" then return end
		btn = PetBattleFrame.BottomFrame.ForfeitButton
		tex = btn:CreateTexture()
		tex:SetDrawLayer("BACKGROUND", 1)
		tex:SetBlendMode("ADD")
		tex:SetPoint("BOTTOMLEFT", 2, 2)
		tex:SetPoint("BOTTOMRIGHT", -2, 2)
		tex:SetTexture(1, 0.82, 0, 0.5)
		tex:Hide()
		btn.HotKey:Show()
		btn.HotKey:SetText(6)
		EV.RegisterEvent("PET_BATTLE_OVER", function()
			btn.SelectedHighlight:Hide()
		end)
		return "remove"
	end
	if IsAddOnLoaded("Blizzard_PetBattleUI") then
		onLoaded(nil, "Blizzard_PetBattleUI")
	else
		EV.RegisterEvent("ADDON_LOADED", onLoaded)
	end
	function f:Stop(arg1)
		tex:Hide()
		btn:UnlockHighlight()
		if arg1 == "over" then
			btn.SelectedHighlight:Hide()
		end
	end
	function f:OnClick(_, down)
		if down then
			self.start = GetTime()
			tex:Show()
			btn:LockHighlight()
		else
			if GetTime() - self.start >= LIMIT and not IsLeftShiftKeyDown() then
				C_PetBattles.ForfeitGame()
			end
			f:Stop("up")
		end
	end
	
	f:Hide()
	f:SetAttribute("_onstate-battle", [[if newstate == "on" then self:SetBindingClick(false, "6", self:GetName()) else self:ClearBindings() self:CallMethod("Stop", "over") self:Hide() end]])
	f:SetAttribute("_onclick", [[self[down and "Show" or "Hide"](self) self:CallMethod("OnClick", button, down)]])
	RegisterStateDriver(f, "battle", "[petbattle] on; off")
	f:RegisterForClicks("AnyUp", "AnyDown")
	f:SetScript("OnUpdate", function(self)
		local pg = math.min(1, math.max(0.001, (GetTime()-self.start)/LIMIT))
		tex:SetHeight((tex:GetParent():GetHeight()-4)*pg)
		if pg == 1 then
			btn:UnlockHighlight()
			btn.SelectedHighlight:Show()
		end
	end)
end

local function updateBorder(self, rarity)
	local border = self and (self.Border or self.BorderAlive)
	if border and rarity then
		border:SetVertexColor(ITEM_QUALITY_COLORS[rarity-1].r, ITEM_QUALITY_COLORS[rarity-1].g, ITEM_QUALITY_COLORS[rarity-1].b)
	end
end
EV.RegisterEvent("PET_BATTLE_OPENING_START", function()
	if PetBattleFrame then
		updateBorder(PetBattleFrame.ActiveEnemy, C_PetBattles.GetBreedQuality(2, 1))
		updateBorder(PetBattleFrame.Enemy2, C_PetBattles.GetBreedQuality(2, 2))
		updateBorder(PetBattleFrame.Enemy3, C_PetBattles.GetBreedQuality(2, 3))
	end
end)

EV.RegisterEvent("PET_BATTLE_PET_CHANGED", function(_, team)
	if team == 1 then
		local bf = PetBattleFrame.BottomFrame
		local ab = bf.abilityButtons
		for i=1,#ab do
			ab[i].SelectedHighlight:Hide()
		end
		bf.CatchButton.SelectedHighlight:Hide()
		bf.ForfeitButton.SelectedHighlight:Hide()
	end
end)